/******************************************************************************/
/*                                                                            */
/*         SAS Program to Convert SAS Export Files to SAS Data Files          */
/*                           TIMSS 2007  User Guide                           */
/*                                                                            */
/******************************************************************************/

OPTIONS NONOTES ;

* Specify the file type ;
* <type> must be edited ;

%LET TYPE = <type> ;

* Specify the path for the sas export files following the format x:\xxx\ ;
* <exppath> must be edited ;

%LET EXPPATH = <exppath> ;

* Specify the path for the SAS data files following the format x:\xxx\ ;
* <datpath> must be edited ;

%LET DATPATH = <datpath> ;

%MACRO DOIT ;

   * Specify the list of countries to be processed ;

   %IF %UPCASE(%SUBSTR(&TYPE,1,1)) = A %THEN %DO ; * 4th grade countries ;

      %LET COUNTRY = DZA ARM AUS AUT TWN COL CZE DNK SLV ENG
                     GEO DEU HKG HUN IRN ITA JPN KAZ KWT LVA
                     LTU MNG MAR NLD NZL NOR QAT RUS SCO SGP
                     SVK SVN SWE TUN UKR USA YEM ADU CAB CBC
                     COT CQU UMA UMN ;

   %END ;

   %IF %UPCASE(%SUBSTR(&TYPE,1,1)) = B %THEN %DO ; * 8th grade countries ;

      %LET COUNTRY = DZA ARM AUS BHR BIH BWA BGR TWN COL CYP
                     CZE EGY SLV ENG GEO GHA HKG HUN IDN IRN
                     ISR ITA JPN JOR KOR KWT LBN LTU MYS MLT
                     MNG MAR NOR OMN PSE QAT ROM RUS SAU SCO
                     SCG SGP SVN SWE SYR THA TUN TUR UKR USA
                     ADU BSQ CBC COT CQU UMA UMN ;

   %END ;

   %LET I = 1 ;
   %DO %WHILE(%LENGTH(%SCAN(&COUNTRY,&I))) ;
      %LET CTRY = %SCAN(&COUNTRY,&i) ;

      PROC CIMPORT FILE="&EXPPATH&TYPE&CTRY.M4.EXP"
                   DATA="&DATPATH&TYPE&CTRY.M4" ;
      RUN;

      %LET I = %EVAL(&I + 1) ;
   %END ;

%MEND DOIT ;

%DOIT ;
